Index: trunk/LMDZ.MARS/libf/phymars/surfini.F
===================================================================
--- trunk/LMDZ.MARS/libf/phymars/surfini.F	(revision 1127)
+++ trunk/LMDZ.MARS/libf/phymars/surfini.F	(revision 1130)
@@ -8,4 +8,6 @@
      &                     albedo_h2o_ice, inert_h2o_ice, albedodat,
      &                     albedice
+      use mod_grid_phy_lmdz, only : klon_glo ! # of physics point on full grid
+      use mod_phys_lmdz_para, only : is_master, gather, scatter
       IMPLICIT NONE
 c=======================================================================
@@ -27,14 +29,14 @@
 #include "datafile.h"
 
-      INTEGER ngrid,ig,icap,iq,alternate
-      REAL  piceco2(ngrid),psolaralb(ngrid,2)
-      REAL qsurf(ngrid,nqmx) !tracer on surface (kg/m2)
+      integer,intent(in) :: ngrid ! number of atmospheric columns
+      real,intent(in) :: piceco2(ngrid) ! CO2 ice thickness
+      real,intent(inout) :: qsurf(ngrid,nqmx) ! tracer on surface (kg/m2)
+      real,intent(out) :: psolaralb(ngrid,2) ! albedo
+
+      INTEGER ig,icap,iq,alternate
       REAL icedryness ! ice dryness
       
       ! longwatercaptag is watercaptag. Trick for some compilers
       LOGICAL, DIMENSION(100000) :: longwatercaptag
-
-      EXTERNAL ISMIN,ISMAX
-      INTEGER ISMIN,ISMAX
       
 ! There are 3 different modes for ice distribution:
@@ -53,5 +55,9 @@
       REAL        zelat,zelon 
 
+#ifdef CPP_PARA
       INTEGER nb_ice(ngrid,2)              ! number of counts | detected ice for GCM grid
+#else
+      INTEGER nb_ice(klon_glo,2)
+#endif
       INTEGER latice(jjm,2),lonice (iim,2) ! number of counts | detected ice along lat & lon axis
 
@@ -64,6 +70,22 @@
       
       character (len=100) :: zedatafile
+
+      ! to handle parallel cases
+#if CPP_PARA
+      logical watercaptag_glo(klon_glo)
+      real dryness_glo(klon_glo)
+      real lati_glo(klon_glo)
+      real long_glo(klon_glo)
+#else
+      logical watercaptag_glo(ngrid)
+      real dryness_glo(ngrid)
+      real lati_glo(ngrid)
+      real long_glo(ngrid)
+#endif
+
 c
 c=======================================================================
+! Initialize watercaptag (default is false)
+      watercaptag_glo(:)=.false.
 
 c     water ice outliers
@@ -93,8 +115,8 @@
          endif
          
-         write(*,*) "Ice dryness ?"
+         write(*,*) "surfini: Ice dryness ?"
          icedryness=1. ! default value
          call getin("icedryness",icedryness)
-         write(*,*) " icedryness = ",icedryness
+         write(*,*) "surfini: icedryness = ",icedryness
          dryness (:) = icedryness
          
@@ -125,11 +147,19 @@
 #else
 
-
-
-      IF (ngrid .eq. 1) THEN ! special case for 1d --> do nothing
+      ! To be able to run in parallel, we work on the full grid
+      ! and dispatch results afterwards
+
+      ! start by geting latitudes and logitudes on full grid
+      ! (in serial mode, this is just a copy)
+      call gather(lati,lati_glo)
+      call gather(long,long_glo)
+
+      if (is_master) then
+
+        IF (ngrid .eq. 1) THEN ! special case for 1d --> do nothing
       
          print*, 'ngrid = 1, do no put ice caps in surfini.F'
 
-      ELSE IF (icelocationmode .eq. 1) THEN
+        ELSE IF (icelocationmode .eq. 1) THEN
       
          print*,'Surfini: ice caps defined from surface.nc'
@@ -144,11 +174,11 @@
 
            
-        zedatafile = trim(datafile)
+         zedatafile = trim(datafile)
  
         
-        ierr=nf90_open(trim(zedatafile)//'/surface.nc',
-     &  NF90_NOWRITE,nid)
+         ierr=nf90_open(trim(zedatafile)//'/surface.nc',
+     &   NF90_NOWRITE,nid)
      
-      IF (ierr.NE.nf90_noerr) THEN
+         IF (ierr.NE.nf90_noerr) THEN
        write(*,*)'Error : cannot open file surface.nc '
        write(*,*)'(in phymars/surfini.F)'
@@ -160,45 +190,45 @@
        write(*,*)' http://www.lmd.jussieu.fr/~forget/datagcm/datafile'
        CALL ABORT
-      ENDIF
-      
-      
-      ierr=nf90_inq_varid(nid, string, nvarid)
-      if (ierr.ne.nf90_noerr) then
-        write(*,*) 'surfini error, cannot find ',trim(string)
-        write(*,*) ' in file ',trim(zedatafile),'/surface.nc'
-        write(*,*)trim(nf90_strerror(ierr))
-        stop
-      endif
-
-      ierr=nf90_get_var(nid, nvarid, zdata)
-
-      if (ierr.ne.nf90_noerr) then
-        write(*,*) 'surfini: error failed loading ',trim(string)
-        write(*,*)trim(nf90_strerror(ierr))
-        stop
-      endif
+         ENDIF
+      
+      
+         ierr=nf90_inq_varid(nid, string, nvarid)
+         if (ierr.ne.nf90_noerr) then
+          write(*,*) 'surfini error, cannot find ',trim(string)
+          write(*,*) ' in file ',trim(zedatafile),'/surface.nc'
+          write(*,*)trim(nf90_strerror(ierr))
+          stop
+         endif
+
+         ierr=nf90_get_var(nid, nvarid, zdata)
+
+         if (ierr.ne.nf90_noerr) then
+          write(*,*) 'surfini: error failed loading ',trim(string)
+          write(*,*)trim(nf90_strerror(ierr))
+          stop
+         endif
  
                      
-      ierr=nf90_close(nid)
+         ierr=nf90_close(nid)
  
 
-      nb_ice(:,1) = 1 ! default: there is no ice
-      latice(:,1) = 1
-      lonice(:,1) = 1
-      nb_ice(:,2) = 0
-      latice(:,2) = 0
-      lonice(:,2) = 0
-      !print*,'jjm,iim',jjm,iim ! jjm =  nb lati , iim = nb longi
-
-      ! loop over the GCM grid - except for poles (ig=1 and ngrid)
-      do ig=2,ngrid-1
-      
-        ! loop over the surface file grid      
-        do i=1,imd
-          do j=1,jmd
-            zelon = i - 180.
-            zelat = 90. - j 
-            if ((abs(lati(ig)*180./pi-zelat) .le. 90./real(jjm)) .and.
-     &        (abs(long(ig)*180./pi-zelon) .le. 180./real(iim))) then
+         nb_ice(:,1) = 1 ! default: there is no ice
+         latice(:,1) = 1
+         lonice(:,1) = 1
+         nb_ice(:,2) = 0
+         latice(:,2) = 0
+         lonice(:,2) = 0
+         !print*,'jjm,iim',jjm,iim ! jjm =  nb lati , iim = nb longi
+
+         ! loop over the GCM grid - except for poles (ig=1 and ngrid)
+         do ig=2,klon_glo-1
+      
+          ! loop over the surface file grid      
+          do i=1,imd
+           do j=1,jmd
+             zelon = i - 180.
+             zelat = 90. - j 
+            if ((abs(lati_glo(ig)*180./pi-zelat).le.90./real(jjm)) .and.
+     &        (abs(long_glo(ig)*180./pi-zelon).le.180./real(iim))) then
               ! count all points in that GCM grid point
               nb_ice(ig,1) = nb_ice(ig,1) + 1
@@ -207,23 +237,23 @@
      &           nb_ice(ig,2) = nb_ice(ig,2) + 1
              endif
-          enddo
-        enddo  
+           enddo
+          enddo  
 
         ! projection of nb_ice on GCM lat and lon axes
-        latice(1+(ig-2)/iim,:) =
+          latice(1+(ig-2)/iim,:) =
      &     latice(1+(ig-2)/iim,:) + nb_ice(ig,:)
-        lonice(1+mod(ig-2,iim),:) = 
+          lonice(1+mod(ig-2,iim),:) = 
      &     lonice(1+mod(ig-2,iim),:) + nb_ice(ig,:) ! lonice is USELESS ...
 
-      enddo ! of do ig=2,ngrid-1
+         enddo ! of do ig=2,klon_glo-1
      
 
      
-      ! special case for poles
-      nb_ice(1,2)   = 1  ! ice prescribed on north pole
-      latice(1,:)   = nb_ice(1,:)
-      lonice(1,:)   = nb_ice(1,:)
-      latice(jjm,:) = nb_ice(ngrid,:)
-      lonice(iim,:) = nb_ice(ngrid,:)
+         ! special case for poles
+         nb_ice(1,2)   = 1  ! ice prescribed on north pole
+         latice(1,:)   = nb_ice(1,:)
+         lonice(1,:)   = nb_ice(1,:)
+         latice(jjm,:) = nb_ice(ngrid,:)
+         lonice(iim,:) = nb_ice(ngrid,:)
       
      
@@ -241,39 +271,39 @@
       
     
-      ! loop over GCM latitudes. CONSIDER ONLY NORTHERN HEMISPHERE
-      do i=1,jjm/2
-      step  = 1. ! threshold to add ice cap
-      count = 0. ! number of ice GCM caps at this latitude
-      ! ratiolat is the ratio of area covered by ice within this GCM latitude range
-      ratiolat  = real(latice(i,2))/real(latice(i,1))
-      !print*,'i',i,(i-1)*iim+2,i*iim+1
+         ! loop over GCM latitudes. CONSIDER ONLY NORTHERN HEMISPHERE
+         do i=1,jjm/2
+          step  = 1. ! threshold to add ice cap
+          count = 0. ! number of ice GCM caps at this latitude
+          ! ratiolat is the ratio of area covered by ice within this GCM latitude range
+          ratiolat  = real(latice(i,2))/real(latice(i,1))
+          !print*,'i',i,(i-1)*iim+2,i*iim+1
      
-        ! put ice caps while there is not enough ice,
-        ! as long as the threshold is above 20%
-        do while ( (count .le. ratiolat*iim ) .and. (step .ge. 0.2))
-          count = 0.
-          ! loop over GCM longitudes
-          do j=1,iim
+          ! put ice caps while there is not enough ice,
+          ! as long as the threshold is above 20%
+          do while ( (count .le. ratiolat*iim ) .and. (step .ge. 0.2))
+           count = 0.
+           ! loop over GCM longitudes
+           do j=1,iim
             ! if the detected ice ratio in the GCM grid point 
             ! is more than 'step', then add ice
             if (real(nb_ice((i-1)*iim+1+j,2)) 
      &        / real(nb_ice((i-1)*iim+1+j,1)) .ge. step) then
-                  watercaptag((i-1)*iim+1+j) = .true.
+                  watercaptag_glo((i-1)*iim+1+j) = .true.
                   count = count + 1
             endif
-          enddo ! of do j=1,iim
+           enddo ! of do j=1,iim
+           !print*, 'step',step,count,ratiolat*iim
+           step = step - 0.01
+          enddo ! of do while
           !print*, 'step',step,count,ratiolat*iim
-          step = step - 0.01
-        enddo ! of do while
-      !print*, 'step',step,count,ratiolat*iim
-
-      enddo ! of do i=1,jjm/2
+
+         enddo ! of do i=1,jjm/2
             
 
-      ELSE IF (icelocationmode .eq. 2) THEN
-      
-        print*,'Surfini: predefined ice caps'
-      
-        if ((iim .eq. 32) .and. (jjm .eq. 24)) then ! 32x24
+        ELSE IF (icelocationmode .eq. 2) THEN
+      
+         print*,'Surfini: predefined ice caps'
+      
+         if ((iim .eq. 32) .and. (jjm .eq. 24)) then ! 32x24
            
           print*,'water ice caps distribution for 32x24 resolution'
@@ -288,5 +318,5 @@
 !---------------------   OUTLIERS  ----------------------------
 
-        else if ((iim .eq. 64) .and. (jjm .eq. 48)) then ! 64x48
+         else if ((iim .eq. 64) .and. (jjm .eq. 48)) then ! 64x48
 
           print*,'water ice caps distribution for 64x48 resolution'
@@ -323,42 +353,43 @@
 
             
-        else if (ngrid .ne. 1) then
+         else if (klon_glo .ne. 1) then
         
-      print*,'No predefined ice location for this resolution :',iim,jjm
-      print*,'Please change icelocationmode in surfini.F'
-      print*,'Or add some new definitions ...'
-      call abort
+          print*,'No predefined ice location for this resolution :',
+     &           iim,jjm
+          print*,'Please change icelocationmode in surfini.F'
+          print*,'Or add some new definitions ...'
+          call abort
           
-        endif
-
-        do ig=1,ngrid
-          if (longwatercaptag(ig)) watercaptag(ig) = .true.
-        enddo
-
-
-      ELSE IF (icelocationmode .eq. 3) THEN
-      
-        print*,'Surfini: ice caps defined by lat and lon values'
-
-         do ig=1,ngrid
+         endif
+
+         do ig=1,klon_glo
+          if (longwatercaptag(ig)) watercaptag_glo(ig) = .true.
+         enddo
+
+
+        ELSE IF (icelocationmode .eq. 3) THEN
+      
+         print*,'Surfini: ice caps defined by lat and lon values'
+
+         do ig=1,klon_glo
          
 c-------- Towards olympia planitia water caps -----------
 c-------------------------------------------------------- 
 
-       if ( ( ( lati(ig)*180./pi .ge. 77.  ) .and. ! cap #2
-     .           ( lati(ig)*180./pi .le. 80.  ) .and.
-     .           ( long(ig)*180./pi .ge. 110. ) .and.
-     .           ( long(ig)*180./pi .le. 181. ) )
+          if ( ( ( lati_glo(ig)*180./pi .ge. 77.  ) .and. ! cap #2
+     .           ( lati_glo(ig)*180./pi .le. 80.  ) .and.
+     .           ( long_glo(ig)*180./pi .ge. 110. ) .and.
+     .           ( long_glo(ig)*180./pi .le. 181. ) )
      .         .or.
 
-     .         ( ( lati(ig)*180./pi .ge. 75.  ) .and. ! cap #4 (Korolev crater)
-     .           ( lati(ig)*180./pi .le. 76.  ) .and.
-     .           ( long(ig)*180./pi .ge. 150. ) .and.
-     .           ( long(ig)*180./pi .le. 168. ) )
+     .         ( ( lati_glo(ig)*180./pi .ge. 75.  ) .and. ! cap #4 (Korolev crater)
+     .           ( lati_glo(ig)*180./pi .le. 76.  ) .and.
+     .           ( long_glo(ig)*180./pi .ge. 150. ) .and.
+     .           ( long_glo(ig)*180./pi .le. 168. ) )
      .         .or.
-     .         ( ( lati(ig)*180./pi .ge. 77 ) .and. ! cap #5
-     .           ( lati(ig)*180./pi .le. 80.  ) .and.
-     .           ( long(ig)*180./pi .ge. -150.) .and.
-     .           ( long(ig)*180./pi .le. -110.) ) )
+     .         ( ( lati_glo(ig)*180./pi .ge. 77 ) .and. ! cap #5
+     .           ( lati_glo(ig)*180./pi .le. 80.  ) .and.
+     .           ( long_glo(ig)*180./pi .ge. -150.) .and.
+     .           ( long_glo(ig)*180./pi .le. -110.) ) )
      .         then
              
@@ -370,20 +401,20 @@
                endif !end if alternate = 0
                
-       endif
+          endif
 
 c----------- Opposite olympia planitia water cap --------
 c-------------------------------------------------------- 
 
-        if ( ( ( lati(ig)*180./pi     .ge.  80 ) .and.
-     .         ( lati(ig)*180./pi     .le.  84 ) )
+          if ( ( ( lati_glo(ig)*180./pi     .ge.  80 ) .and.
+     .         ( lati_glo(ig)*180./pi     .le.  84 ) )
      .         .and.
-     .       ( ( long(ig)*180./pi .lt. -95. ) .or.       !!! 32x24
-     .         ( long(ig)*180./pi .gt.  85. ) ) ) then   !!! 32x24
-!     .     ( ( ( long(ig)*180./pi .ge. -29. ) .and.       !!! 64x48
-!     .         ( long(ig)*180./pi .le.  90. ) ) .or.      !!! 64x48
-!     .       ( ( long(ig)*180./pi .ge. -77. ) .and.       !!! 64x48
-!     .         ( long(ig)*180./pi .le. -70. ) ) ) ) then  !!! 64x48
-        !   watercaptag(ig)=.true.
-        endif
+     .       ( ( long_glo(ig)*180./pi .lt. -95. ) .or.       !!! 32x24
+     .         ( long_glo(ig)*180./pi .gt.  85. ) ) ) then   !!! 32x24
+!     .     ( ( ( long_glo(ig)*180./pi .ge. -29. ) .and.       !!! 64x48
+!     .         ( long_glo(ig)*180./pi .le.  90. ) ) .or.      !!! 64x48
+!     .       ( ( long_glo(ig)*180./pi .ge. -77. ) .and.       !!! 64x48
+!     .         ( long_glo(ig)*180./pi .le. -70. ) ) ) ) then  !!! 64x48
+        !   watercaptag_glo(ig)=.true.
+          endif
 
 
@@ -391,13 +422,13 @@
 c-------------------------------------------------------- 
 
-      if (abs(lati(ig)*180./pi).gt.80)
-     .       watercaptag(ig)=.true.
+          if (abs(lati_glo(ig)*180./pi).gt.80)
+     .          watercaptag_glo(ig)=.true.
            
 c--------------------------------------------------------
 c--------------------------------------------------------
-      end do ! of (ngrid)
-
-
-       ELSE
+         end do ! of (klon_glo)
+
+
+        ELSE
       
          print*, 'In surfini.F, icelocationmode is ', icelocationmode
@@ -405,20 +436,27 @@
          call abort 
 
-       ENDIF ! of if (icelocation)
+        ENDIF ! of if (icelocation)
        
        
         ! print caps locations - useful for plots too 
-        print*,'latitude | longitude | ig'
-        do ig=1,ngrid
-          dryness (ig) = icedryness
-
-          if (watercaptag(ig)) then
-             print*,'ice water cap', lati(ig)*180./pi,
-     .              long(ig)*180./pi, ig
+        print*,'surfini: latitude | longitude | ig'
+        do ig=1,klon_glo
+          dryness_glo(ig) = icedryness
+
+          if (watercaptag_glo(ig)) then
+             print*,'surfini: ice water cap', lati_glo(ig)*180./pi,
+     &              long_glo(ig)*180./pi, ig
           endif
         enddo
        
+       endif !of if (is_master)
+       
+       ! Now scatter fields watercaptag and dryness from master to all
+       ! (is just a plain copy in serial mode)
+       call scatter(dryness_glo,dryness)
+       call scatter(watercaptag_glo,watercaptag)
+       
 #endif      
-
+! end of #else of #ifdef MESOSCALE
        ENDIF ! (caps & water)
        
@@ -439,8 +477,8 @@
               psolaralb(ig,2)=albedodat(ig)
          END DO
-         PRINT*,'minimum albedo sans water caps',
-     s     albedodat(ISMIN(ngrid,albedodat,1))
-         PRINT*,'maximum albedo sans water caps',
-     s     albedodat(ISMAX(ngrid,albedodat,1))
+         PRINT*,'surfini: minimum albedo without water caps',
+     &          minval(albedodat)
+         PRINT*,'surfini: maximum albedo without water caps',
+     &          maxval(albedodat)
 
 c        initial albedo if permanent H2O ice is present 
@@ -453,8 +491,8 @@
             ENDIF
            END DO
-           PRINT*,'minimum albedo avec water caps',
-     s     psolaralb(ISMIN(ngrid,psolaralb,1),1)
-           PRINT*,'maximum albedo avec water caps',
-     s     psolaralb(ISMAX(ngrid,psolaralb,1),1)
+           PRINT*,'surfini: minimum albedo with water caps',
+     &            minval(albedodat)
+           PRINT*,'surfini: maximum albedo with water caps',
+     &            maxval(albedodat)
 
          ENDIF
@@ -465,8 +503,8 @@
        DO ig=1,ngrid
          IF (piceco2(ig) .GT. 0.) THEN
-             IF(ig.GT.ngrid/2+1) THEN
-                icap=2
+             IF(lati(ig).LT. 0.) THEN
+                icap=2 ! Southern hemisphere
              ELSE
-                icap=1
+                icap=1 ! Northern hemisphere
              ENDIF
              psolaralb(ig,1) = albedice(icap)
@@ -514,11 +552,11 @@
            endif 
           end do
-          PRINT*,'minimum albedo avec givre et co2',
-     s     psolaralb(ISMIN(ngrid,psolaralb,1),1)
-          PRINT*,'maximum albedo avec givre et co2',
-     s     psolaralb(ISMAX(ngrid,psolaralb,1),1)
+          PRINT*,'surfini: minimum albedo with frost and co2',
+     &            minval(albedodat)
+          PRINT*,'surfini: maximum albedo with frost and co2',
+     &            maxval(albedodat)
        ELSE
          watercaptag(:) = .false.
-       END IF
+       END IF ! OF IF(water)
          
       RETURN
Index: trunk/LMDZ.MARS/libf/phymars/tabfi.F
===================================================================
--- trunk/LMDZ.MARS/libf/phymars/tabfi.F	(revision 1127)
+++ trunk/LMDZ.MARS/libf/phymars/tabfi.F	(revision 1130)
@@ -48,4 +48,6 @@
      &                     iceradius, dtemisice, iceradius
       use yomaer_h, only: tauvis
+      use iostart, only: get_var
+      use mod_phys_lmdz_para, only: is_parallel
       implicit none
  
@@ -67,12 +69,14 @@
 c Arguments
 c ---------
-      INTEGER nid,nvarid,tab0
-      INTEGER*4 day_ini
-      INTEGER Lmodif
-      INTEGER lmax
-      REAL p_rad,p_omeg,p_g,p_mugaz,p_daysec,time,peri_ls
+      INTEGER,INTENT(IN) :: nid,tab0
+      INTEGER*4,INTENT(OUT) :: day_ini
+      INTEGER,INTENT(IN) :: Lmodif
+      INTEGER,INTENT(OUT) :: lmax
+      REAL,INTENT(OUT) :: p_rad,p_omeg,p_g,p_mugaz,p_daysec,time
 
 c Variables
 c ---------
+      INTEGER :: nvarid
+      REAL :: peri_ls
       INTEGER length
       parameter (length = 100)
@@ -81,9 +85,8 @@
       INTEGER size
       CHARACTER modif*20
-
-c Fonctions DRS et autres
-c -----------------------
-      INTEGER setname, cluvdb, getdat
-
+      LOGICAL :: found
+
+      write(*,*)"tabfi: nid=",nid," tab0=",tab0," Lmodif=",Lmodif
+      
 c-----------------------------------------------------------------------
 c  Initialization of various physical constants to defaut values (nid = 0 case)
@@ -150,20 +153,26 @@
 c Read 'controle' array
 c
-      ierr = NF_INQ_VARID (nid, "controle", nvarid)
-      IF (ierr .NE. NF_NOERR) THEN
-         PRINT*, "Tabfi: Could not find <controle> data"
-         CALL abort
-      ENDIF
-#ifdef NC_DOUBLE
-      ierr = NF_GET_VAR_DOUBLE(nid, nvarid, tab_cntrl)
-#else
-      ierr = NF_GET_VAR_REAL(nid, nvarid, tab_cntrl)
-#endif
-      IF (ierr .NE. NF_NOERR) THEN
-         PRINT*, "Tabfi: Failed reading <controle> array"
-         CALL abort
-      ENDIF
-
-       print*,'tabfi: tab_cntrl',tab_cntrl
+!      ierr = NF_INQ_VARID (nid, "controle", nvarid)
+!      IF (ierr .NE. NF_NOERR) THEN
+!         PRINT*, "Tabfi: Could not find <controle> data"
+!         CALL abort
+!      ENDIF
+!#ifdef NC_DOUBLE
+!      ierr = NF_GET_VAR_DOUBLE(nid, nvarid, tab_cntrl)
+!#else
+!      ierr = NF_GET_VAR_REAL(nid, nvarid, tab_cntrl)
+!#endif
+!      IF (ierr .NE. NF_NOERR) THEN
+!         PRINT*, "Tabfi: Failed reading <controle> array"
+!         CALL abort
+!      ENDIF
+
+       call get_var("controle",tab_cntrl,found)
+       if (.not.found) then
+         write(*,*)"tabfi: Failed reading <controle> array"
+         call abort
+       else
+         write(*,*)'tabfi: tab_cntrl',tab_cntrl
+       endif
 c
 c  Initialization of some physical constants
@@ -269,4 +278,10 @@
 c-----------------------------------------------------------------------
 c	 Modifications...
+! NB: Modifying controls should only be done by newstart, and in seq mode
+      if ((Lmodif.eq.1).and.is_parallel) then
+        write(*,*) "tabfi: Error modifying tab_control should",
+     &             " only happen in serial mode (eg: by newstart)"
+        stop
+      endif
 c-----------------------------------------------------------------------
 
Index: trunk/LMDZ.MARS/libf/phymars/testphys1d.F
===================================================================
--- trunk/LMDZ.MARS/libf/phymars/testphys1d.F	(revision 1127)
+++ trunk/LMDZ.MARS/libf/phymars/testphys1d.F	(revision 1130)
@@ -3,6 +3,6 @@
 ! to use  'getin'
       USE ioipsl_getincom, only: getin
-      use infotrac, only: nqtot, tnom
-      use comsoil_h, only: volcapa, layer, mlayer, inertiedat
+      use infotrac, only: nqtot, tname
+      use comsoil_h, only: volcapa, layer, mlayer, inertiedat, nsoilmx
       use comgeomfi_h, only: lati, long, area
       use comdiurn_h, only: sinlat
@@ -13,4 +13,7 @@
       use slope_mod, only: theta_sl, psi_sl
       use yomaer_h, only: tauvis
+      use control_mod, only: day_step
+      use phyredem, only: physdem0,physdem1
+      use comgeomphy, only: initcomgeomphy
       IMPLICIT NONE
 
@@ -36,4 +39,5 @@
 #include "dimensions.h"
 #include "dimphys.h"
+      integer, parameter :: ngrid = 1 !(2+(jjm-1)*iim - 1/jjm)
 !#include "dimradmars.h"
 !#include "comgeomfi.h"
@@ -47,5 +51,5 @@
 !#include "comsaison.h"
 !#include "yomaer.h"
-#include "control.h"
+!#include "control.h"
 #include "comvert.h"
 #include "netcdf.inc"
@@ -70,5 +74,5 @@
       REAL play(nlayermx)   ! Pressure at the middle of the layers (Pa)
       REAL plev(nlayermx+1) ! intermediate pressure levels (pa)
-      REAL psurf,tsurf      
+      REAL psurf,tsurf(1)      
       REAL u(nlayermx),v(nlayermx)  ! zonal, meridional wind
       REAL gru,grv   ! prescribed "geostrophic" background wind
@@ -77,6 +81,6 @@
       REAL,ALLOCATABLE :: qsurf(:) ! tracer surface budget (e.g. kg.m-2)
       REAL tsoil(nsoilmx)   ! subsurface soik temperature (K)
-      REAL co2ice           ! co2ice layer (kg.m-2)
-      REAL emis             ! surface layer
+      REAL co2ice(1)        ! co2ice layer (kg.m-2)
+      REAL emis(1)          ! surface layer
       REAL q2(nlayermx+1)   ! Turbulent Kinetic Energy
       REAL zlay(nlayermx)   ! altitude estimee dans les couches (km)
@@ -111,4 +115,8 @@
 c INITIALISATION
 c=======================================================================
+! initialize "serial/parallel" related stuff
+!      CALL init_phys_lmdz(iim,jjp1,llm,1,(/(jjm-1)*iim+2/))
+      CALL init_phys_lmdz(iim,jjm+1,llm,1,(/(jjm-1)*iim+2/))
+      call initcomgeomphy
 
 c ------------------------------------------------------
@@ -203,5 +211,5 @@
         endif
         ! allocate arrays:
-        allocate(tnom(nq))
+        allocate(tname(nq))
         allocate(q(nlayermx,nq))
         allocate(qsurf(nq))
@@ -212,5 +220,5 @@
         ! read tracer names from file traceur.def
         do iq=1,nq
-          read(90,*,iostat=ierr) tnom(iq)
+          read(90,*,iostat=ierr) tname(iq)
           if (ierr.ne.0) then
             write(*,*) 'testphys1d: error reading tracer names...'
@@ -228,5 +236,5 @@
         do iq=1,nq
           txt=""
-          write(txt,"(a)") tnom(iq)
+          write(txt,"(a)") tname(iq)
           write(*,*)"  tracer:",trim(txt)
           ! CO2
@@ -366,5 +374,5 @@
         nq=1
         ! allocate arrays:
-        allocate(tnom(nq))
+        allocate(tname(nq))
         allocate(q(nlayermx,nq))
         allocate(qsurf(nq))
@@ -374,5 +382,5 @@
         do iq=1,nq
           write(str7,'(a1,i2.2)')'q',iq
-          tnom(iq)=str7
+          tname(iq)=str7
         enddo
       ! and just to be clean, also initialize tracers to zero for physdem1
@@ -549,5 +557,5 @@
 c  CO2 ice on the surface
 c  -------------------
-      co2ice=0.E+0 ! default value for co2ice
+      co2ice(1)=0.E+0 ! default value for co2ice
       PRINT *,'Initial CO2 ice on the surface (kg.m-2)'
       call getin("co2ice",co2ice)
@@ -558,5 +566,5 @@
 c  ----------
       emis=emissiv
-      IF (co2ice.eq.1.E+0) THEN
+      IF (co2ice(1).eq.1.E+0) THEN
          emis=emisice(1) ! northern hemisphere
          IF(lati(1).LT.0) emis=emisice(2) ! southern hemisphere
@@ -615,5 +623,5 @@
       DO isoil=1,nsoil
          inertiedat(1,isoil)=inertiedat(1,1) ! soil thermal inertia
-         tsoil(isoil)=tsurf  ! soil temperature
+         tsoil(isoil)=tsurf(1)  ! soil temperature
       ENDDO
 
@@ -817,2 +825,3 @@
 
 #include "../dyn3d/disvert.F"
+#include "../dyn3d/abort_gcm.F"
Index: trunk/LMDZ.MARS/libf/phymars/thermcell_main_mars.F90
===================================================================
--- trunk/LMDZ.MARS/libf/phymars/thermcell_main_mars.F90	(revision 1127)
+++ trunk/LMDZ.MARS/libf/phymars/thermcell_main_mars.F90	(revision 1130)
@@ -43,4 +43,5 @@
 
       USE comtherm_h
+      use planetwide_mod, only: planetwide_maxval
 
       IMPLICIT NONE
@@ -764,5 +765,8 @@
 ! ===========================================================================
 
-      zlmax=MAXVAL(lmax(:))+2
+      !zlmax=MAXVAL(lmax(:))+2 ! OK, but in serial mode only; use planet
+      call planetwide_maxval(lmax,zlmax)
+      zlmax=zlmax+2
+      
       if (zlmax .ge. nlayer) then
         print*,'thermals have reached last layer of the model'
@@ -790,8 +794,9 @@
 
 ! llmax is the index of the heighest thermal in the simulation domain
-      llmax=1
-      do ig=1,ngrid
-         if (lalim(ig)>llmax) llmax=lalim(ig)
-      enddo
+      !llmax=1
+      !do ig=1,ngrid
+      !   if (lalim(ig)>llmax) llmax=lalim(ig)
+      !enddo
+      call planetwide_maxval(lalim,llmax)
 
 ! Integral of a**2/(rho* Delta z), see equation 13 of appendix 4.2 in paper
Index: trunk/LMDZ.MARS/libf/phymars/vdif_kc.F
===================================================================
--- trunk/LMDZ.MARS/libf/phymars/vdif_kc.F	(revision 1127)
+++ trunk/LMDZ.MARS/libf/phymars/vdif_kc.F	(revision 1130)
@@ -32,15 +32,15 @@
 c 
 c.......................................................................
-      REAL dt,g
-      REAL zlev(ngrid,nlay+1)
-      REAL zlay(ngrid,nlay)
-      REAL u(ngrid,nlay)
-      REAL v(ngrid,nlay)
-      REAL teta(ngrid,nlay)
-      REAL cd(ngrid)
-      REAL q2(ngrid,nlay+1)
-      REAL km(ngrid,nlay+1)
-      REAL kn(ngrid,nlay+1)
-      REAL zq(ngrid,nlay,nq)
+      REAL,INTENT(IN) :: dt,g
+      REAL,INTENT(IN) :: zlev(ngrid,nlay+1)
+      REAL,INTENT(IN) :: zlay(ngrid,nlay)
+      REAL,INTENT(IN) :: u(ngrid,nlay)
+      REAL,INTENT(IN) :: v(ngrid,nlay)
+      REAL,INTENT(IN) :: teta(ngrid,nlay)
+      REAL,INTENT(IN) :: cd(ngrid)
+      REAL,INTENT(INOUT) :: q2(ngrid,nlay+1)
+      REAL,INTENT(OUT) :: km(ngrid,nlay+1)
+      REAL,INTENT(OUT) :: kn(ngrid,nlay+1)
+      REAL,INTENT(IN) :: zq(ngrid,nlay,nq)
 c.......................................................................
 c
@@ -247,4 +247,11 @@
       nlev=nlay+1
       
+      ! Other initializations of local variables (to be clean)
+      long(:,:)=0.
+      n2(:,:)=0.
+      sn(:,:)=0.
+      snq2(:,:)=0.
+      sm(:,:)=0.
+      smq2(:,:)=0.
 c.......................................................................
 c  Special treatment for co2
@@ -381,6 +388,6 @@
         gninf=.false.
         gnsup=.false.
-        long(igrid,ilev)=long(igrid,ilev)
-        long(igrid,ilev)=long(igrid,ilev)
+        long(igrid,ilev)=long(igrid,ilev) ! not very useful...
+        long(igrid,ilev)=long(igrid,ilev) ! not very useful...
 c
         IF (gn.lt.gnmin) THEN
@@ -609,4 +616,18 @@
 c.......................................................................
 c
+
+!        call writediagfi(ngrid,'vdif_kc_q2','','',3,q2(:,1:nlay))
+!        call writediagfi(ngrid,'vdif_kc_km','','',3,km(:,1:nlay))
+!        call writediagfi(ngrid,'vdif_kc_kn','','',3,kn(:,1:nlay))
+!        call writediagfi(ngrid,'vdif_kc_unsdz','','',3,unsdz(:,1:nlay))
+!        call writediagfi(ngrid,'vdif_kc_unsddecz','','',3,
+!     &                   unsdzdec(:,1:nlay))
+!        call writediagfi(ngrid,'vdif_kc_q','','',3,q(:,1:nlay))
+!        call writediagfi(ngrid,'vdif_kc_kmpre','','',3,
+!     &                   kmpre(:,1:nlay))
+!        call writediagfi(ngrid,'vdif_kc_long','','',3,long(:,1:nlay))
+!        call writediagfi(ngrid,'vdif_kc_sn','','',3,sn(:,1:nlay))
+!        call writediagfi(ngrid,'vdif_kc_sm','','',3,sm(:,1:nlay))
+
       RETURN
       END
Index: trunk/LMDZ.MARS/libf/phymars/vdifc.F
===================================================================
--- trunk/LMDZ.MARS/libf/phymars/vdifc.F	(revision 1127)
+++ trunk/LMDZ.MARS/libf/phymars/vdifc.F	(revision 1130)
@@ -56,5 +56,4 @@
       REAL,INTENT(IN) :: pu(ngrid,nlay),pv(ngrid,nlay)
       REAL,INTENT(IN) :: ph(ngrid,nlay)
-      REAL :: pt(ngrid,nlay)
       REAL,INTENT(IN) :: ptsrf(ngrid),pemis(ngrid)
       REAL,INTENT(IN) :: pdufi(ngrid,nlay),pdvfi(ngrid,nlay)
@@ -63,6 +62,6 @@
       REAL,INTENT(OUT) :: pdudif(ngrid,nlay),pdvdif(ngrid,nlay)
       REAL,INTENT(OUT) :: pdtsrf(ngrid),pdhdif(ngrid,nlay)
-      REAL,INTENT(IN) ::pcapcal(ngrid)
-      REAL pq2(ngrid,nlay+1)
+      REAL,INTENT(IN) :: pcapcal(ngrid)
+      REAL,INTENT(INOUT) :: pq2(ngrid,nlay+1)
 
 c    Argument added for condensation:
@@ -86,4 +85,5 @@
 c   ------
 
+      REAL :: pt(ngrid,nlay)
       REAL ust(ngrid),tst(ngrid)
  
@@ -363,18 +363,18 @@
 ! Some usefull diagnostics for the new surface layer parametrization :
 
-!        call WRITEDIAGFI(ngrid,'pcdv',
+!        call WRITEDIAGFI(ngrid,'vdifc_zcdv_true',
 !     &              'momentum drag','no units',
 !     &                         2,zcdv_true)
-!        call WRITEDIAGFI(ngrid,'pcdh',
+!        call WRITEDIAGFI(ngrid,'vdifc_zcdh_true',
 !     &              'heat drag','no units',
 !     &                         2,zcdh_true)
-!        call WRITEDIAGFI(ngrid,'ust',
+!        call WRITEDIAGFI(ngrid,'vdifc_ust',
 !     &              'friction velocity','m/s',2,ust)
-!       call WRITEDIAGFI(ngrid,'tst',
+!       call WRITEDIAGFI(ngrid,'vdifc_tst',
 !     &              'friction temperature','K',2,tst)
-!        call WRITEDIAGFI(ngrid,'rm-1',
+!        call WRITEDIAGFI(ngrid,'vdifc_zcdv',
 !     &              'aerodyn momentum conductance','m/s',
 !     &                         2,zcdv)
-!        call WRITEDIAGFI(ngrid,'rh-1',
+!        call WRITEDIAGFI(ngrid,'vdifc_zcdh',
 !     &              'aerodyn heat conductance','m/s',
 !     &                         2,zcdh)
@@ -384,5 +384,5 @@
        IF (.not. calltherm) THEN
 
-       CALL vdif_kc(ptimestep,g,pzlev,pzlay
+       CALL vdif_kc(ngrid,nlay,nq,ptimestep,g,pzlev,pzlay
      &              ,pu,pv,ph,zcdv_true
      &              ,pq2,zkv,zkh,zq)
